/* Problem URL: https://codeforces.com/contest/1829/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int n, m;

vvl grid;
V<V<bool>> vis;

ll dfs(int i, int j)
{
    vis[i][j] = true;

    int add[4][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
    ll ans = 0;

    for (auto &k : add) {
        int id = i + k[0];
        int jd = j + k[1];

        if (id >= 0 && id < n && jd >= 0 && jd < m && !vis[id][jd] && grid[id][jd] != 0) {
            ans += dfs(id, jd);
        }
    }

    return ans + grid[i][j];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;

        vis.assign(n, V<bool>(m, false));
        grid.assign(n, vl(m));


        cin >> grid;
        ll ans = 0;

        rep(i, n) {
            rep(j, m) {
                if (grid[i][j] != 0) {
                    rmax(ans, dfs(i, j));
                }
            }
        }

        cout << ans << '\n';
    }
}
